jQuery(document).ready(function($) {
	var min_message = [];
	var radius_message = [];
	var the_response;
	var userMadeSelection = false;
	var run_geo = false;
	var failsafe = false;
	var map;
	var marker;
	init_updated();

	function init_updated() {
		if (szbd.precise_address === 'always') {
			init_delivery_map();
		} else if (szbd.precise_address === 'at_fail') {
			jQuery('body').one('szbd_init_map', function() {
				init_delivery_map();
			});
		}
		jQuery('#place_order').prop('disabled', true).addClass('szbd-disabled');
		jQuery('body').off('updated_checkout.szbd').on('updated_checkout.szbd', function() {
			if (true) {
				if (typeof marker !== 'undefined' && marker !== null) {
					let location = marker.getPosition();
					update_when_new_marker(location);
					return;
				}
			}
			jQuery('#szbd_message').remove();
			jQuery('#place_order').prop('disabled', true).addClass('szbd-disabled');
			update(false);
			min_message = [];
			radius_message = [];
			jQuery('#shipping_method li').off('click.szbd').on('click.szbd', function() {
				userMadeSelection = true;
			});
		});
		jQuery('body').one('updated_checkout.szbd2', function() {
			jQuery('#shipping_method li').each(function() {
				if (jQuery(this).find('input').val().indexOf('szbd-shipping-method') == 0) {
					jQuery(this).attr('szbd', false).hide();
				}
			});
		});
	}

	function update_when_new_marker(loc) {
		jQuery('#szbd_message').remove();
		jQuery('#place_order').prop('disabled', true).addClass('szbd-disabled');
		update(loc);
		min_message = [];
		radius_message = [];
		jQuery('#shipping_method li').off('click.szbd').on('click.szbd', function() {
			userMadeSelection = true;
		});
	}

	function end() {
		jQuery('#szbd_message').remove();
		if (jQuery('#shipping_method li[szbd="true"]').length === 0 && jQuery('#shipping_method li').not('#shipping_method li[szbd="true"]').not('#shipping_method li[szbd="false"]').length === 0) {
			if (min_message.length !== 0) {
				var sorted_min_message = _.sortBy(min_message, 'min_amount');
				if (jQuery('#shipping_method').find("#szbd_message").length) {
					jQuery('#shipping_method').find("#szbd_message").html(sorted_min_message[0].min_message);
				} else {
					jQuery('#shipping_method').append('<span id="szbd_message">' + sorted_min_message[0].min_message + '</>');
				}
			} else if (radius_message.length !== 0) {
				var sorted_radius_message = _.sortBy(radius_message, 'min_radius').reverse();
				if (jQuery('#shipping_method').find("#szbd_message").length) {
					jQuery('#shipping_method').find("#szbd_message").html(sorted_radius_message[0].radius_message);
				} else {
					jQuery('#shipping_method').append('<span id="szbd_message">' + sorted_radius_message[0].radius_message + '</>');
				}
			} else {
				if (jQuery('#shipping_method').find("#szbd_message").length) {
					jQuery('#shipping_method').find("#szbd_message").html(szbd.checkout_string_1);
				} else {
					jQuery('#shipping_method').append('<span id="szbd_message">' + szbd.checkout_string_1 + '</>');
				}
			}
			jQuery('#place_order').prop('disabled', true).addClass('szbd-disabled');
			jQuery('#order_review .order-total .woocommerce-Price-amount').hide();
		} else {
			jQuery('#place_order').prop('disabled', false).removeClass('szbd-disabled');
			jQuery('#order_review .order-total .woocommerce-Price-amount').show();
		}
		// To develop in future versions
		/*
		var selected_method = jQuery('input[type=radio]:checked', '#shipping_method').val();
		 if(selected_method.includes('szbd'))
		 {
			jQuery('.woocommerce-shipping-totals.shipping').after('<tr><th>' + 'Shipping Address' + '</th><td>'+ address_string + '</td></tr>');
		 }*/
	}

	function set_min_radius(min, unit) {
		radius_message.push({
			min_radius: min,
			radius_message: szbd.checkout_string_3 + ' ' + min + unit
		});
	}

	function update(from_marker) {
		try {
			jQuery('.szbd-debug').remove();
			jQuery('table.woocommerce-checkout-review-order-table').addClass('processing').block({
				message: null,
				overlayCSS: {
					background: '#fff',
					opacity: 0.6
				}
			});
			var country = $('#billing_country').val() ? $('#billing_country').val() : "",
				state = $('#billing_state').val() ? $('#billing_state').val() : "",
				postcode = $('input#billing_postcode').val() ? $('input#billing_postcode').val() : "";
			var s_country = country;
			var s_state = state;
			var s_postcode = postcode;
			if ($('#ship-to-different-address').find('input').is(':checked')) {
				s_country = $('#shipping_country').val();
				s_state = $('#shipping_state').val() ? $('#shipping_state').val() : "";
				s_postcode = $('input#shipping_postcode').val() ? $('input#shipping_postcode').val() : "";
			}
			var data = {
				'action': 'check_address_2',
				country: s_country,
				state: s_state,
				postcode: s_postcode,
			};
			$.post(
				woocommerce_params.ajax_url,
				data,
				function(response) {
					the_response = response;
					if ((the_response.status === true) && !(the_response.szbd_zones === null || the_response.szbd_zones === undefined || the_response.szbd_zones.length == 0)) {
						if (from_marker !== false) {
							do_geolocation(from_marker, 'OK', 'OK', true, null);
						} else if (the_response.do_address_lookup != true) {
							do_geolocation(null, null, 'OK', false, null);
						} else if (the_response.delivery_address !== false) {
							do_geolocation(the_response.delivery_address, 'OK', 'OK', true, null);
						} else {
							var ok_types = [];
							var country = $('#billing_country').val() ? $('#billing_country').val() : the_response.cust_loc.country;
							streetnumber = $('#billing_number').val() ? $('#billing_number').val() : "",
								postcode = $('input#billing_postcode').val() ? $('input#billing_postcode').val() : "",
								s_company = $('input#billing_company').val() ? $('input#billing_company').val() + ',' : "",
								city = $('#billing_city').val() ? $('#billing_city').val() : "",
								address = $('input#billing_address_1').val() ? $('input#billing_address_1').val() : "",
								address_2 = $('input#billing_address_2').val() ? $('input#billing_address_2').val() : "",
								state = $('#billing_state').val() ? $('#billing_state').val() : "",
								state_text = $('#billing_state').val() ? $("#billing_state option:selected").text() : "";
							var is_postcode = $('input#billing_postcode').val() ? true : false;
							var s_country = country;
							var s_streetnumber = streetnumber;
							var s_state = state;
							var s_state_text = state_text;
							var s_postcode = postcode;
							var s_city = city;
							var s_address = address;
							var s_address_2 = address_2;
							if ($('#ship-to-different-address').find('input').is(':checked')) {
								s_country = $('#shipping_country').val() ? $('#shipping_country').val() : the_response.cust_loc.country;
								s_state = $('#shipping_state').val() ? $('#shipping_state').val() : "";
								s_state_text = $('#shipping_state').val() ? $("#shipping_state option:selected").text() : "";
								s_streetnumber = $('input#shipping_number').val() ? $('input#shipping_number').val() : "";
								s_postcode = $('input#shipping_postcode').val() ? $('input#shipping_postcode').val() : "";
								is_postcode = $('input#shipping_postcode').val() ? true : false;
								s_company = $('input#shipping_company').val() ? $('input#shipping_company').val() + ',' : "";
								s_city = $('#shipping_city').val() ? $('#shipping_city').val() : "";
								s_address = $('input#shipping_address_1').val() ? $('input#shipping_address_1').val() : "";
								s_address_2 = $('input#shipping_address_2').val() ? $('input#shipping_address_2').val() : "";
							}
							var comp;
							var postcode_ = s_postcode !== undefined ? s_postcode.replace(" ", "") : '';
							if (s_country == 'IL') {
								s_address = s_address + ',' + s_address_2 + ',' + s_city + ' ' + s_postcode;
								comp = {
									country: s_country,
									administrativeArea: s_city,
									locality: s_city,
								};
							} else if (s_country == 'CA') {
								s_address = s_address + ',' + s_address_2 + ',' + s_city + ' ' + s_postcode + ',' + s_state;
								comp = {
									country: s_country,
									administrativeArea: s_state
								};
								if (s_state === "") {
									delete comp.administrativeArea;
								}
							} else if (s_country == 'RO') {
								s_address = s_address + ',' + s_address_2 + ',' + s_city + ' ' + s_postcode + ',' + s_state;
								comp = {
									country: s_country,
									administrativeArea: s_state,
								};
								if (s_state === "") {
									delete comp.administrativeArea;
								}
							} else if (s_country == 'RU') {
								s_address = s_address + ',' + s_address_2 + ',' + s_city + ',' + s_state;
								comp = {
									country: s_country,
									administrativeArea: s_state,
									locality: s_city,
								};
								if (s_state === "") {
									delete comp.administrativeArea;
								}
							} else if (s_country == 'AO') {
								s_address = s_address + ',' + s_address_2 + ',' + s_city + ',' + s_state;
								comp = {
									country: s_country,
									administrativeArea: s_state,
									locality: s_city,
								};
								if (s_state === "") {
									delete comp.administrativeArea;
								}
							} else if (s_country == 'ES') {
								s_address = s_address + ',' + s_address_2 + ',' + s_city + ',' + s_state;
								comp = {
									country: s_country,
									locality: s_city,
									postalCode: postcode_,
								};
							} else if (s_country == 'IE') {
								s_address = s_address + ',' + s_address_2 + ',' + s_city + ' ' + postcode_;
								comp = {
									country: s_country,
									postalCode: postcode_,
								};
								ok_types = ["street_address", "subpremise", "premise", "postal_code", "establishment"];
							} else if (s_country == 'BR') {
								s_address = s_address + ' ' + s_streetnumber + ', ' + postcode_ + ',' + s_city + ' , ' + s_state_text;
								comp = {
									country: s_country,
									locality: s_city,
								};
							} else if (s_country == 'PL') {
								s_address = s_address + ',' + s_address_2 + ',' + s_city + ' ' + s_country;
								comp = {
									locality: s_city,
									country: s_country
								};
							} else {
								s_address = s_address + ',' + s_address_2 + ',' + s_city + ' ' + postcode_ + ',' + s_state;
								comp = {
									postalCode: postcode_,
									locality: s_city,
									country: s_country
								};
								if (is_postcode === false) {
									delete comp.postalCode;
								}
								if (szbd.deactivate_postcode == 1) {} else {
									delete comp.locality;
								}
							}
							if (szbd.deactivate_postcode == 1) {
								delete comp.postalCode;
							}
							if ( comp.locality === '') {
								delete comp.locality;
							}
							if (szbd.precise_address !== 'no') {
								delete comp.locality;
								delete comp.postalCode;
							}
							// Geocode the address
							var geocoder = new google.maps.Geocoder();
							run_geo = true;
							geocoder.geocode({
								'address': /* s_company + */ s_address,
								'componentRestrictions': comp
							}, function(results, status) {
								run_geo = false;
								if (szbd.debug == 1) {
									jQuery('.woocommerce-notices-wrapper:first-child').html('<div class="woocommerce-info szbd-debug"><h4>GEOCODE:</h4><br>' + JSON.stringify(results) + '</div>');
								}
								do_geolocation(results, status, google.maps.GeocoderStatus.OK, false, ok_types);
							});
							jQuery('table.woocommerce-checkout-review-order-table').removeClass('processing').unblock();
						}
					} else {
						jQuery('table.woocommerce-checkout-review-order-table').removeClass('processing').unblock();
						end();
						jQuery('#shipping_method').fadeIn();
					}
				}).then(function() {});
		} catch (err) {
			ignore_szbd(false);
		}
	}

	function do_geolocation(results, status, ok_status, has_address, ok_types) {
		try {
			var delivery_address;
			var drive_time_car_Promise;
			var drive_time_bike_Promise;
			var drive_dist_Promise;
			var bicycle_dist_Promise;
			var radius_Promise;
			var latitude;
			var longitude;
			if (has_address === false) {
				ok_types = (!Array.isArray(ok_types) || !ok_types.length) ? ["street_address", "subpremise", "premise", "establishment", "route"] : ok_types;
				ok_types = szbd.precise_address == 'at_fail' ? _.without(ok_types, 'route') : ok_types;
				if (status != google.maps.GeocoderStatus.OK) {
					latitude = null;
					longitude = null;
					delivery_address = null;
				} else if (status === ok_status && findCommonElements(results[0].types, ok_types)) {
					latitude = results[0].geometry.location.lat();
					longitude = results[0].geometry.location.lng();
					delivery_address = results[0].geometry.location;
					if (szbd.precise_address == 'at_fail') {
						update_store_map(results[0].geometry.location, false, true);
						marker.setMap(null);
						marker = null;
						$('#szbd_checkout_field').slideUp();
					}
				} else {
					latitude = null;
					longitude = null;
					delivery_address = null;
					if (status === ok_status && szbd.precise_address == 'at_fail') {
						jQuery('body').trigger('szbd_init_map');
						update_store_map(results[0].geometry.location, true, false);
					}
				}
			} else {
				delivery_address = results;
				latitude = delivery_address.lat();
				longitude = delivery_address.lng();
				if (szbd.precise_address !== 'no') {
					update_store_map(delivery_address, false, true);
				}
			}
			if (the_response.store_address !== false) {
				radius_Promise = the_response.do_radius && delivery_address !== null ? calcRadius(delivery_address, the_response.store_address, true) : false;
			} else {
				radius_Promise = the_response.do_radius && delivery_address !== null ? calcRadius(delivery_address, szbd.store_address, false) : false;
			}
			if (the_response.delivery_duration_driving !== false || the_response.distance_driving !== false) {
				drive_time_car_Promise = drive_dist_Promise = [the_response.delivery_duration_driving, the_response.distance_driving];
			} else {
				drive_time_car_Promise = drive_dist_Promise = (the_response.do_driving_time_car || the_response.do_driving_dist || the_response.do_dynamic_rate_car) && delivery_address !== null ? calcRoute(latitude, longitude, szbd.store_address, 'DRIVING') : false;
			}
			if (the_response.delivery_duration_bicycle !== false || the_response.distance_bicycle !== false) {
				drive_time_bike_Promise = bicycle_dist_Promise = [the_response.delivery_duration_bicycle, the_response.distance_bicycle];
			} else {
				drive_time_bike_Promise = bicycle_dist_Promise = (the_response.do_driving_time_bike || the_response.do_bike_dist || the_response.do_dynamic_rate_bike) && delivery_address !== null ? calcRoute(latitude, longitude, szbd.store_address, 'BICYCLING') : false;
			}
			$.when(drive_time_car_Promise, drive_time_bike_Promise, drive_dist_Promise, bicycle_dist_Promise, radius_Promise).then(function(driving_car, driving_bike, driving_dist, bicycling_dist, radius) {
				// Check if the custom delivery method is applicable
				if ((the_response.status === true) && !(the_response.szbd_zones === null || the_response.szbd_zones === undefined || the_response.szbd_zones.length == 0)) {
					the_response.szbd_zones.forEach(function(element, index) {
						if (element.drawn_map !== false) {
							var path = [];
							for (i = 0; element.geo_coordinates !== null && i < (element.geo_coordinates).length; i++) {
								path.push(new google.maps.LatLng(element.geo_coordinates[i][0], element.geo_coordinates[i][1]));
							}
							var polygon = new google.maps.Polygon({
								paths: path
							});
							var location = new google.maps.LatLng((latitude), (longitude));
							var address_is_in_zone = google.maps.geometry.poly.containsLocation(location, polygon);
							//	alert([location,address_is_in_zone]);
						} else if (element.max_radius !== false) {
							var max_radius = element.distance_unit == 'miles' ? element.max_radius.radius * 1609.344 : element.max_radius.radius * 1000;
							var max_ok = max_radius > radius && radius !== false;
							if (status === ok_status && delivery_address != null && !max_ok) {
								set_min_radius(element.max_radius.radius, element.distance_unit);
							}
						}
						if (element.max_driving_distance !== false) {
							var max_dist = element.distance_unit == 'miles' ? element.max_driving_distance.distance * 1609.344 : element.max_driving_distance.distance * 1000;
							var max_driving_distance_ok = max_dist > driving_dist[1] || max_dist > driving_car[1] || max_dist > driving_bike[1];
						}
						if (element.max_driving_time_car !== false) {
							var max_driving_time_car = element.max_driving_time_car.time * 60 > driving_car[0];
						} else if (element.max_driving_time_bike !== false) {
							var max_driving_time_bike = element.max_driving_time_bike.time * 60 > driving_bike[0];
						}
						var condition_0 = (typeof address_is_in_zone == 'undefined' || address_is_in_zone);
						var condition_1 = (typeof max_ok == 'undefined' || max_ok);
						var condition_2 = typeof max_driving_distance_ok == 'undefined' || max_driving_distance_ok;
						var condition_3 = typeof max_driving_time_car == 'undefined' || max_driving_time_car;
						var condition_4 = typeof max_driving_time_bike == 'undefined' || max_driving_time_bike;
						var ok;
						if (element.drawn_map.bool && !condition_0) {
							ok = false;
						} else if (element.max_radius.bool && !condition_1) {
							ok = false;
						} else if (element.max_driving_distance.bool && !condition_2) {
							ok = false;
						} else if (element.max_driving_time_car.bool && !condition_3) {
							ok = false;
						} else if (element.max_driving_time_bike.bool && !condition_4) {
							ok = false;
						} else if ((typeof address_is_in_zone !== 'undefined' && address_is_in_zone) ||
							(typeof max_ok !== 'undefined' && max_ok) ||
							(typeof max_driving_distance_ok !== 'undefined' && max_driving_distance_ok) ||
							(typeof max_driving_time_car !== 'undefined' && max_driving_time_car) ||
							(typeof max_driving_time_bike !== 'undefined' && max_driving_time_bike)
						) {
							ok = true;
						} else if (typeof address_is_in_zone == 'undefined' &&
							typeof max_ok == 'undefined' &&
							typeof max_driving_distance_ok == 'undefined' &&
							typeof max_driving_time_car == 'undefined' &&
							typeof max_driving_time_bike == 'undefined'
						) {
							ok = true;
						} else {
							ok = false;
						}
						if (!ok) {
							jQuery('#shipping_method li :input').filter(function() {
								return this.value == element.value_id;
							}).closest('li').attr('szbd', false).hide();
						} else {
							jQuery('#shipping_method li :input').filter(function() {
								return this.value == element.value_id;
							}).closest('li').attr('szbd', true).show();
						}
						if (index >= the_response.szbd_zones.length - 1) {
							jQuery('#shipping_method').fadeIn();
							jQuery('table.woocommerce-checkout-review-order-table').removeClass('processing').unblock();
							var adr = the_response.delivery_address_string;
							end();
						}
					});
				} else {
					jQuery('table.woocommerce-checkout-review-order-table').removeClass('processing').unblock();
					jQuery('#shipping_method').fadeIn();
					var adr = the_response.delivery_address_string;
					end();
				}
			}).done(function() {
				select_method();
			});
		} catch (err) {
			ignore_szbd(false);
		}
	}

	function calcRoute(lati, longi, store_address, mode) {
		try {
			var N = 0;
			var store_loc;
			var time_def = $.Deferred();
			if (szbd.store_address_picked == 1) {
				store_loc = new google.maps.LatLng(store_address.lat, store_address.lng);
			} else {
				store_loc = store_address.store_address + ',' + store_address.store_postcode + ',' + store_address.store_city + ',' + store_address.store_state + ',' + store_address.store_country;
			}
			var request = {
				origin: store_loc,
				destination: {
					lat: lati,
					lng: longi
				},
				travelMode: mode,
				drivingOptions: {
					departureTime: new Date(Date.now() + N), // for the time N milliseconds from now.
					trafficModel: 'bestguess'
				}
			};
			var directionsService = new google.maps.DirectionsService();
			directionsService.route(request, function(response, status) {
				if (szbd.debug == 1) {
					jQuery('.woocommerce-notices-wrapper:first-child').append('<div class="woocommerce-info szbd-debug"><h4>CALC ROUTE::</h4><br>' + JSON.stringify(response) + '</div>');
				}
				if (status == 'OK') {
					var time = (typeof response.routes[0].legs[0].duration_in_traffic !== 'undefined') ? response.routes[0].legs[0].duration_in_traffic.value : response.routes[0].legs[0].duration.value;
					var dist = response.routes[0].legs[0].distance.value;
					var del_address = response.routes[0].legs[0].end_address;
					time_def.resolve([time, dist, del_address]);
				} else {
					time_def.resolve('error');
				}
			});
			return time_def.promise();
		} catch (err) {
			ignore_szbd(false);
		}
	}

	function calcRadius(delivery_address, store_address, has_address) {
		try {
			var radius = $.Deferred();
			var r;
			var store_loc;
			if (has_address) {
				store_loc = new google.maps.LatLng(store_address.lat, store_address.lng);
				delivery_address = delivery_address instanceof google.maps.LatLng ? delivery_address :  new google.maps.LatLng(delivery_address.lat, delivery_address.lng);

				r = compute_radius(store_loc, delivery_address);
				if (szbd.debug == 1) {
					jQuery('.woocommerce-notices-wrapper:first-child').append('<div class="woocommerce-info szbd-debug"><h4>CALC RADIUS:</h4><br>Radius:' + JSON.stringify(r) + '</div>');
				}
				radius.resolve(r);
			} else if (szbd.store_address_picked == 1) {
				store_loc = new google.maps.LatLng(store_address.lat, store_address.lng);
				r = compute_radius(store_loc, delivery_address);
				if (szbd.debug == 1) {
					jQuery('.woocommerce-notices-wrapper:first-child').append('<div class="woocommerce-info szbd-debug"><h4>CALC RADIUS:</h4><br>Radius:' + JSON.stringify(r) + '</div>');
				}
				radius.resolve(r);
			} else {
				var geocode_storeaddress = new google.maps.Geocoder();
				geocode_storeaddress.geocode({
						'address': store_address.store_address + ',' + store_address.store_postcode + ',' + store_address.store_city + ',' + store_address.store_state + ',' + store_address.store_country
					},
					function(results, status) {
						if (szbd.debug == 1) {
							jQuery('.woocommerce-notices-wrapper:first-child').append('<div class="woocommerce-info szbd-debug"><h4>CALC RADIUS::</h4><br>Radius:' + JSON.stringify(compute_radius(results[0].geometry.location, delivery_address)) + '<br>STORE ADDRESS:' + JSON.stringify(results) + '<br>DELIVERY ADDRESS:' + JSON.stringify(delivery_address) + '</div>');
						}
						if (status == 'OK') {
							var r = compute_radius(results[0].geometry.location, delivery_address);
							radius.resolve(r);
						} else {
							radius.resolve('error');
						}
					});
			}
			return radius.promise();
		} catch (err) {
			ignore_szbd(false);
		}
	}

	function compute_radius(s, d) {
		return google.maps.geometry.spherical.computeDistanceBetween(s, d);
	}
	// Helping methods
	function findCommonElements(arr1, arr2) {
		return arr1.some(function(item){return arr2.includes(item);});
	}
	window.gm_authFailure = function() {
		ignore_szbd(true);
	};

	function ignore_szbd(auth_error) {
		if (!run_geo && auth_error == true) {
			return;
		} else if (!auth_error && !failsafe) {
			var el;
			jQuery('#shipping_method li').each(function() {
				el = jQuery(this).find('input').val();
				if (el.indexOf("szbd-shipping-method") >= 0) {
					jQuery(this).attr('szbd', false).hide();
				}
			});
			jQuery('#shipping_method').fadeIn();
			jQuery('table.woocommerce-checkout-review-order-table').removeClass('processing').unblock();
			end();
			return;
		}
		jQuery('body').off('update_checkout.szbdcatch').on('update_checkout.szbdcatch', function() {
			jQuery('#place_order').prop('disabled', false);
		});
		jQuery('body').off('updated_checkout.szbdcatch').on('updated_checkout.szbdcatch', function() {
			jQuery('#shipping_method').fadeIn();
			var el;
			jQuery('#shipping_method li').each(function() {
				el = jQuery(this).find('input').val();
				if (el.indexOf("szbd-shipping-method") >= 0) {
					jQuery(this).not('[szbd="true"]').remove();
				}
			});
			if (jQuery('#shipping_method li').length === 0) {
				jQuery('#place_order').prop('disabled', true);
			}
			select_method();
			jQuery('table.woocommerce-checkout-review-order-table').removeClass('processing').unblock();
		});
		var el;
		jQuery('#shipping_method li').each(function() {
			el = jQuery(this).find('input').val();
			if (el.indexOf("szbd-shipping-method") >= 0) {
				jQuery(this).not('[szbd="true"]').remove();
			}
		});
		if (jQuery('#shipping_method li').length === 0) {
			jQuery('#place_order').prop('disabled', true);
		}
		jQuery('#shipping_method').fadeIn();
		jQuery('table.woocommerce-checkout-review-order-table').removeClass('processing').unblock();
		jQuery('body').off('updated_checkout.my2');
		select_method();
	}

	function select_method() {
		if (szbd.select_top_method == 1) {
			if (!userMadeSelection) {
				userMadeSelection = false;
				if ((jQuery('#shipping_method li :input').not('#shipping_method li[szbd="false"] :input').first().is(":checked") !== true) && jQuery('#shipping_method li').length !== 1) {
					jQuery('#shipping_method li').not('#shipping_method li[szbd="false"]').first().find('input').prop('checked', true).trigger('change');
				}
			} else {
				userMadeSelection = false;
			}
		} else {
			if ((jQuery('#shipping_method li :input').not('#shipping_method li[szbd="false"] :input').is(":checked") !== true) && jQuery('#shipping_method li').length !== 1) {
				jQuery('#shipping_method li').not('#shipping_method li[szbd="false"]').first().find('input').prop('checked', true).change();
			}
		}
	}
	// Map methods
	function update_store_map(loc, is_fail, is_precise_address) {
		initMap(loc, is_fail, is_precise_address);
	}

	function init_delivery_map() {
		initMap(null, false, false);
		szbd_save_location();
	}

	function initMap(uluru, is_fail, is_precise_address) {
		try {
			if (is_fail) {
				jQuery('#szbd_checkout_field').fadeIn();
			}
			var mapOptions;
			var markerOptions;
			if (typeof uluru == 'undefined' || uluru == null) {
				mapOptions = {
					zoom: 1,
					center: {
						lat: 0,
						lng: 0
					},
					disableDefaultUI: true,
					zoomControl: true
				};
				map = new google.maps.Map(
					document.getElementById('szbd_map'), mapOptions);
			} else {
				mapOptions = {
					zoom: 18,
					center: uluru,
					disableDefaultUI: true,
					zoomControl: true
				};
				map = new google.maps.Map(
					document.getElementById('szbd_map'), mapOptions);
				markerOptions = {
					position: uluru,
					map: map,
					draggable: true,
				};
				if (is_precise_address) {
					marker = new google.maps.Marker(markerOptions);
				}
			}
			jQuery('#szbd_map').height(400);
			google.maps.event.addListener(map, 'click', function(event) {
				placeMarker(event.latLng);
			});
			marker.addListener('dragend', function(event) {
				placeMarker(event.latLng);
			});
		} catch (err) {}
	}

	function placeMarker(location) {
		try {
			if (marker) {
				marker.setPosition(location);
			} else {
				marker = new google.maps.Marker({
					position: location,
					map: map,
					draggable: true,
				});
			}
			if (true) {
				var store_location = marker.getPosition();
				if (store_location) {
					document.getElementById('szbd-picked').value = store_location.lat() + ',' + store_location.lng();
					jQuery(document).off('input.szbd2').on('input.szbd2', '#billing_address_1,#shipping_address_1', function() {
						if (typeof marker !== 'undefined' && marker !== null) {
							marker.setMap(null);
							marker = null;
						}
						document.getElementById('szbd-picked').value = '';
					});
					jQuery('body').trigger('update_checkout');
				}
			} else {
				update_when_new_marker(location);
			}
		} catch (err) {}
	}

	function szbd_save_location() {
		try {
			if ($('#szbd-picked').length) {
				$('form.checkout').off("checkout_place_order").on("checkout_place_order", function() {
					//alert('save');
					var store_location = marker.getPosition();
					if (store_location) {
						document.getElementById('szbd-picked').value = JSON.stringify(store_location);
					} else {
						return;
					}
				});
			} else {
				return;
			}
		} catch (err) {}
	}
});
